/* hnd_msg.c - handle 1 message */
#include "sortmail.h"

#ifdef _USE_xDBM
#include "x_dbm.h"

CSDB_KEY dbm_key_data ;
datum dbm_key = { (char*)&dbm_key_data, sizeof(dbm_key_data) } ;

CSDB_DATA dbm_data_data ;
datum dbm_data= { (char*)&dbm_data_data , sizeof(dbm_data_data) } ;

#endif /*DBM*/

int msgnum=0;

int hnd_msg()
{
HLPTR * hlp_ptr;
int fl_dup;


#ifdef _USE_xDBM
datum dbm_found ;
dbm_data_data.expire = starttime + (long)CSexpire*86400 ;
#endif /*DBM*/

if ( debug_bits && debug_pause ) sleep(debug_pause);
fdebug(DBG_CALL,"DBG: call hnd_msg\n");

msgnum++;

PRINT(PR_NEWLINE,("\n"));

if ( ( print_bits & PR_SPCHDRL ) && PrintHeadLines )
	for (hlp_ptr=hlp_first;hlp_ptr;hlp_ptr=hlp_ptr->next) {
		if ( ( hlp_ptr->flags & HLPF_PRINT ) && hlp_ptr->lineptr )
			printf(PrHdrlineFmt,hlp_ptr->lineptr) ;
		}

PRINT(PR_MSGNUM,(PrMsgNumFmt,msgnum));

fl_dup=0 ; /*!!!*/

#ifdef _USE_xDBM
if ( xdb_file ) {
 dbm_key_data.s_From=	( hlp_From->lineptr ? csumm(hlp_From->dataptr,0) : 0 );
 dbm_key_data.s_Subject=( hlp_Subject->lineptr ? csumm(hlp_Subject->dataptr,0) : 0 );
 dbm_key_data.s_TEXT=	( msgtext ? csumm(msgtext,endmsg) : 0 );

fdebug(DBG_CS,"CS:  F: %5hd S: %5hd T: %6hd\n",
	dbm_key_data.s_From,dbm_key_data.s_Subject,dbm_key_data.s_TEXT) ;

 dbm_found=xdb_fetch(dbm_key) ;
 if ( dbm_found.dptr != NULL ) {
	fl_dup=1 ; /*!!!*/
	PRINT(PR_DUPWARN,("!!! DUP !!!\n"));
	free(dbm_found.dptr);
	if ( DupUpdateKey ) xdb_store(dbm_key,dbm_data) ;
	}
 else
	if (!fl_nwkey) xdb_store(dbm_key,dbm_data) ;
 } /*xdb_file*/
#endif /*DBM*/

if ( fl_dup && !fl_hnddup ) msg_out(oft_dups) ;
else smanalyz();

for (hlp_ptr=hlp_first;hlp_ptr;hlp_ptr=hlp_ptr->next) {
	hlp_ptr->lineptr=NULL ;
	hlp_ptr->dataptr=NULL ;
	if ( hlp_ptr->tr_dataptr ) {
		free(hlp_ptr->tr_dataptr) ;
		hlp_ptr->tr_dataptr=NULL ;
		}
	}

return(0);
}

/*EOF hnd_msg.c*/
