/* smextern.h - sortmail extern variables */

_EXTERN char *__progname; /*For getopt compatibility*/
_EXTERN int retcode ;

/********************* global parameters *********************/
_EXTERN time_t starttime ;

_EXTERN char
	* InputFileName, * EquCharsTab, * SortDefsFile, * REDictFile,
	* REConvRules, * DebugOutFile,
	* OutputDir, * DelHeadLines, * PrintHeadLines, * RegExpStyle,
	* ErrOutFile, * OutFilesTab, * OtherOutFile, * DupsOutFile,
	* CSDBFile, * CSCharSet,
	* PrMsgNumFmt, * PrOutfileFmt, * PrHdrlineFmt,
	* _OFT_FldSeq;
/*	* FMT1_sel, *_FMT2_sel, *_FMT1_out, *_FMT2_out, *_FMT_OFT, *_FMT_RET*/

_EXTERN long debug_bits;

_EXTERN int debug_pause, print_bits;

_EXTERN int del_blank_lines, del_blank_chars, outlinelen,
	CSexpire, DupUpdateKey ;

_EXTERN unsigned long buffer_size ;

_EXTERN int
	max_open_out, max_out_pipes, files_for_pipe, max_sel_level,
	close_out_mode, pipe_mode
	;

_EXTERN char trtab[256], cstrtab[256];

/* compiled regular expressions - statements format */
_EXTERN regexp
	* re_FMT1_sel, * re_FMT2_sel, * re_FMT1_out, * re_FMT2_out,
	* re_FMT_OFT, * re_FMT_RET,
	* re_StartOfMessage
	;

/* control tables pointers */
_EXTERN OP_TAB * opt_origin ;
_EXTERN OFD * oft_first, * oft_dups ;
_EXTERN HLPTR * hlp_first, * hlp_From, * hlp_Subject ;
_EXTERN RE * re_origin;
_EXTERN SR * re_cvt_user ;
_EXTERN SR * re_cvt_dos ;

/* message buffer pointers & flags */
_EXTERN char * msgbuf, * endbuf, * msgtext, * endmsg, * workbuf ;
_EXTERN Flag msg_in_buf, hdr_in_buf ;
_EXTERN Flag fl_suppout, fl_hnddup, fl_nwkey, fl_prevoutzero ;
_EXTERN int msgnum;

/* different common variables */
_EXTERN char LastOpenedFile[] ;
_EXTERN FILE * inputfile, * outfile ;
_EXTERN int default_re_style ;

_EXTERN cf_dsc * cfd_ptr ;	/* config.file descriptor ptr */
_EXTERN int inclevel ;		/* config.file include level */

_EXTERN FILE * dbgout ;

#if   defined(USE_DBM)
_EXTERN int xdb_file;
#elif defined(USE_NDBM)
_EXTERN DBM * xdb_file;
#elif defined(USE_GDBM)
_EXTERN GDBM_FILE xdb_file;
#endif

/*EOF smextern.h*/
