/* sortmail.c */

#include "sortmail.h"

#ifdef _USE_xDBM
#include "x_dbm.h"
#endif

int retcode;

main(margc,margv)
int margc;
char * margv[1];
{
/* build tables */
smconfig(margc,margv);

if ( retcode ) return( retcode ) ;

#ifdef _USE_xDBM
dbexpire();
#endif

/* handle input file */
if ( InputFileName == NULL ) inputfile=stdin ;
else
	if ( ( inputfile=smfopen(InputFileName,"r") ) == NULL ) return(1) ;

if (!retcode) {
	PRINT(PR_STAGE,("Processing input file...\n"));
	readinpt();
	}

/* close all output files, */
PRINT(PR_STAGE,("Close all output files...\n"));

{
OFD * oft_ptr;
close_out_mode=CLOSE_NOW ; /*!*/
for (oft_ptr=oft_first; oft_ptr->next; oft_ptr=oft_ptr->next)
	if ( !(oft_ptr->flags&OFFL_PIPE) ) smcloseo(oft_ptr,CLOSE_NOW);
/* ... and pipes */
for (oft_ptr=oft_first; oft_ptr->next; oft_ptr=oft_ptr->next)
	smcloseo(oft_ptr,CLOSE_NOW);
}

#ifdef _USE_xDBM
if ( xdb_file ) {
	PRINT(PR_STAGE,("Close CS database...\n"));
/*??!!*/ xdb_close();
	PRINT(PR_STAGE,("All done !\n"));
	}
#endif

/* print statistics */
smprstat();

return(retcode) ;

}

void seterror(err)
int err;
{ if ( err > retcode ) retcode=err; }

/*EOF sortmail.c*/
