/* bldrecvt.c */
#include "sortmail.h"

static SR recvtdos[20] = {
{&recvtdos[1],	"\\",	"\\\\"},
{&recvtdos[2],	".",	"\\."},
{&recvtdos[3],	"?",	"."},
{&recvtdos[4],	"*",	".*"},
{&recvtdos[5],	"+",	"\\+"},
{&recvtdos[6],	"^",	"\\^"},
{&recvtdos[7],	"$",	"\\$"},
{&recvtdos[8],	"[",	"\\["},
{&recvtdos[9],	"]",	"\\]"},
{&recvtdos[10],	"(",	"\\("},
{&recvtdos[11],	")",	"\\)"},
{NULL,		"|",	"\\|"}
} ;

SR * re_cvt_user = NULL ;
SR * re_cvt_dos = &recvtdos[0] ;

static char * s_fmt="^('[^']+'|\"[^\"]+\"|[^ \t]+)[ \t]+('[^']+'|\"[^\"]+\"|[^ \t\n\r]+)([ \t\r\n]*|[ \t]+.*)$";

int bldrecvt(infile)
FILE * infile;
{
SR * re_sr_ptr;
char *p, *p1;
regexp * fmt;

if (!infile ) return(1);

if ( (fmt=regcomp(s_fmt))==NULL ) {fprintf(stderr,"Internal error\n");exit(100);}

while ( fgets(workbuf,WORKBUFSIZE-1,infile) ) {
   if ((*workbuf!=' ')&&(*workbuf!='\t')&&(*workbuf!='\n')&&(*workbuf!='\r')){

	if ( !regexec(fmt,workbuf) ) {
		fprintf(stderr,"Error in %s\n",REConvRules);exit(ERROR_CONFIG);}

	re_sr_ptr=(SR*)add_to_chain((ANY_CHAIN**)&re_cvt_user, sizeof(SR) );
	re_sr_ptr->search=( (*fmt->startp[1]!='"' && *fmt->startp[1]!='\'') ?
		strndup( fmt->startp[1],   (fmt->endp[1]-fmt->startp[1])   ) :
		strndup( fmt->startp[1]+1, (fmt->endp[1]-fmt->startp[1]-2) )
		);

	re_sr_ptr->replace=( (*fmt->startp[2]!='"' && *fmt->startp[2]!='\'') ?
		strndup( fmt->startp[2],   (fmt->endp[2]-fmt->startp[2])   ) :
		strndup( fmt->startp[2]+1, (fmt->endp[2]-fmt->startp[2]-2) )
		);

	}
    }

fclose(infile);
return(0);
}
/*EOF bldrecvt.c */
