/* getcfstr.c - get configuration line */
#include "sortmail.h"

char * getcfstr()
{

while (1) {
    while ( fgets(workbuf,WORKBUFSIZE-1,cfd_ptr->file) ) {
      cfd_ptr->linenum++;
      if ( *workbuf=='#' ) continue;
      strtrunc(workbuf);
      if ( !strlen(workbuf) ) continue;

      if ( *workbuf != '.' ) {
		fdebug(DBG_RDCONF,"GETCFSTR: '%s'\n",nonblank(workbuf));
		return(nonblank(workbuf));
		}

      else { /* directive */

	if      ( !strncmp(workbuf,".REGEXP",7) ) cfd_ptr->re_style=RE_STYLE_RE ;
    	else if ( !strncmp(workbuf,".MSDOS",6) )  cfd_ptr->re_style=RE_STYLE_DOS ;
	else if ( !strncmp(workbuf,".USER",5) ) {
		cfd_ptr->re_style=RE_STYLE_USER ;
		if ( !re_cvt_user ) cfgerror("Invalid directive\n",1);
		}/*.USER*/
      	else if ( !strncmp(workbuf,".fileprefix=",12) )
		cfd_ptr->fileprefix=duptoken(workbuf+12," \t");
	else if ( !strncmp(workbuf,".include",8) ) {
		inclevel++;
		if (inclevel>MAXINCLEVEL) cfgerror("include level > max\n",1);
		cfd_ptr++;
		cfd_ptr->filename=duptoken(workbuf+9," \t");
		cfd_ptr->linenum=0;
		cfd_ptr->re_style=(cfd_ptr-1)->re_style;
		cfd_ptr->fileprefix=(cfd_ptr-1)->fileprefix;
  		if ( (cfd_ptr->file=fopen(cfd_ptr->filename,"r")) != 0 ) continue;
		else cfgerror("Can't open include file\n",1);
		}/*.include*/
	else cfgerror("Invalid directive\n",0);

      }/*directive*/

    }/*while fgets*/

/* eof reached*/
    fclose(cfd_ptr->file);
    if ( cfd_ptr->fileprefix && (cfd_ptr->fileprefix != (cfd_ptr-1)->fileprefix))
   	free(cfd_ptr->fileprefix);
    if ( !inclevel ) return(NULL);
    inclevel--;
    cfd_ptr--;
}/*while(1)*/
}/*getcfstr()*/

/*EOF getcfstr.c */

