/* rdconfig.c	- read configuration files V 3.1 */
/* 24 Sep 96	Stanislav Latishko */

#include <stdio.h>
#include <stdlib.h>
#include "rdconfig.h"
#include <string.h>
#if !defined(MSDOS) && !defined(__MSDOS__)
#define strnicmp strncasecmp
#endif

rdconfig(partab,conffile)
PARDEF *partab;
FILE *conffile;
{

char buf[1024];
PARDEF *tabptr;
char *valptr;
int numparms=0;
char * p ;
size_t bytesleft ;

if ( !conffile || !partab ) return(0);

while ( !feof(conffile) ) {
	bytesleft=sizeof(buf)-1;
	fgets(buf,bytesleft,conffile);
	bytesleft-=strlen(buf);
	if ( *buf == '\n' ) continue ;
	if ( *buf == '#' ) continue ;

	p=buf;
	while ( (p=strrchr(p,'\n'))!=NULL && *(p-1)=='\\' ) {
		p--;
		*p='\0';
		fgets(p,bytesleft,conffile);
		bytesleft-=strlen(p);
		}

	tabptr=partab;
	while ( tabptr->parname != NULL ) {
		if ( !strnicmp(buf,tabptr->parname,strlen(tabptr->parname)) ) {
			valptr=buf+strlen(tabptr->parname);
			if ( *tabptr->parvptr )
				sscanf(valptr,tabptr->scanfmt,*tabptr->parvptr);
			else {
				sscanf(valptr,tabptr->scanfmt,buf);
				*tabptr->parvptr=strdup(buf);
				}
			numparms++;
			break;
			}
		else tabptr++ ;
		} ;
	} ;
fclose(conffile);
return(numparms);
}

/*EOF rdconfig.c*/
