/* readinpt.c */
#include "sortmail.h"

FILE * inputfile;

int readinpt()
{
char * cbufptr, * end_of_line ;
/*char ** hdrlptr ;*/
long bytesleft ;
int linelength ;
Flag fl_read_header=0, read_body=0, prev_zeroline=1, read_eof=0 ;
HLPTR * hlp_ptr;

fdebug(DBG_CALL,"READINPT(<%s)\n",InputFileName);

msgbuf=smmalloc((size_t)buffer_size);
endbuf=msgbuf+buffer_size-1;
/*hdrlptr=smmalloc(buffer_size*sizeof(char*));*/

cbufptr=msgbuf;
bytesleft=buffer_size;

#define c_char *cbufptr
#define next_char *(cbufptr+1)
#define prev_char *(cbufptr-1)


/*
। ப  + ='From '     ->  쬮
 + 稭  ஡/⠡樨 -> ப த
 +  ப 		   ->   ?
*/

while ( fgets(cbufptr,
		( bytesleft > MAXINT ? MAXINT : (int)bytesleft ) ,
		inputfile) ) {
	fdebug(DBG_INPUT,"(%d",strlen(cbufptr));
	end_of_line=strchr(cbufptr,'\0');

	if (end_of_line>=endbuf) {
		for (endmsg=end_of_line-1;*endmsg!='\0';endmsg--);
		endmsg++; /*endmsg->last [not complete?] line*/

		PRINT(PR_OVFLWARN,
			("!!! Large message - end of buffer reached!!!\n"));
		if (hdr_in_buf) {
			if ( hnd_msg() ) break; /*ERROR ???*/
			else {
				FlagOn(fl_read_header);
				cbufptr=msgbuf ;
				end_of_line=strchr(cbufptr,'\0');
				}
			}
		else {
			fprintf(stderr,"Message header too large\n");
			msgflush(0);
			}
		}

	while ( *(end_of_line-1)=='\n' || *(end_of_line-1)=='\r' ||
		( ( fl_read_header || del_blank_chars ) &&
			( *(end_of_line-1)==' '||*(end_of_line-1)=='\t')) )
		end_of_line--;
	*end_of_line='\0';
	bytesleft=endbuf-end_of_line;
	linelength=(int)(end_of_line-cbufptr);

	fdebug(DBG_INPUT|HIGHBITOFLONG, "/%d) \'%s\'\n", linelength, cbufptr) ;

/* 砫  */
	if (!linelength) /*  ப */ { prev_zeroline=1 ;
		}
	else /*   ப ... */
		if (fl_read_header && (hlp_ptr=hlp_find(cbufptr)) != NULL ) {
			hlp_ptr->lineptr=cbufptr ;
			hlp_ptr->dataptr=nonblank(strpbrk(cbufptr," \t")) ;
			}
		if (prev_zeroline) /* ... ।  ... */ {
			fdebug(DBG_HNDINP,"DBG:\tprev_zeroline\n");

			if (start_of_message(cbufptr)) /* ...  From */ {
				fdebug(DBG_HNDINP,"DBG:\tStart of message\n");
				endmsg=cbufptr ;

				if (cbufptr!=msgbuf) {
					FlagOn(msg_in_buf) ;
					hnd_msg() ;
					}
				/* * * * * * * * * * * */

				strcpy(msgbuf,cbufptr); /*???*/
				end_of_line=strchr(msgbuf,'\0') ;
				FlagOn(fl_read_header) ;
				FlagOff(hdr_in_buf);
				FlagOff(msg_in_buf);
				}
			else
				if (fl_read_header) /* ... ⥭  */{
					fdebug(DBG_HNDINP,"DBG:\tmessage body\n");
					fl_read_header=0 ; FlagOn(hdr_in_buf);
					msgtext=cbufptr ;
					}
			/*  ᨬ 䫠 ।- */
			if (linelength) prev_zeroline=0 ;
			}

		else if (fl_read_header && (c_char=='\t'||c_char==' ')) {
			strcpy(cbufptr,nonblank(cbufptr));
			prev_char=' ' ;
			end_of_line=(strchr(cbufptr,'\0')) ;
			}

	cbufptr=end_of_line+1 ;/*ࠢ!!!*/
	}/*2*/

fdebug(DBG_INPUT,"INP: EOF\n");

/* After EOF */
*cbufptr='\0';
endmsg=cbufptr;
if ( cbufptr > msgbuf ) {
	if ( hdr_in_buf && prev_zeroline ) {
		FlagOn(msg_in_buf);
		hnd_msg() ;
		}
	else {
		msgflush(1) ;
		return(1) ;
		}
	}

return(0) ;

}

/************/
char * nextstr()
{

}

/*EOF readinpt.c*/
